HDU 1058 Humble Numbers(递推)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1058

题意:丑数是指只有2,3,5 or 7这几个素因数的数(所以1也是丑数),找到第n个丑数。

思路:除了2,3,5,7任何一个丑数都是由另一个丑数乘上2,或3,或5,或7得到的。

所以可以用优先队列,每取出一个丑数就入队他们乘上2,3,5,7得到的四个丑数,这样每个丑数都生成了。复杂度还是不错的,不过按这种方法会生成比较大的数,最终爆掉int,所以要用long long

//93MS 1228K
#include<cstdio>
#include<cstring>
#include<queue>
#define ll long long
using namespace std;
ll ans[6000];
int main()
{
    priority_queue<ll,vector<ll>,greater<ll> >que;
    que.push(1);
    int cnt=0;
    while(!que.empty()){
        if(cnt==5842) break;
        ll t=que.top();
        que.pop();
        if(t<=ans[cnt]) continue;
        ans[++cnt]=t;
        que.push(t*2);
        que.push(t*3);
        que.push(t*5);
        que.push(t*7);
    }
    int n;
    while(~scanf("%d",&n)&&n){
        if(n%10==1&&n%100!=11)printf("The %dst humble number is %I64d.\n",n,ans[n]);
        else if(n%10==2&&n%100!=12)printf("The %dnd humble number is %I64d.\n",n,ans[n]);
        else if(n%10==3&&n%100!=13) printf("The %drd humble number is %I64d.\n",n,ans[n]);
        else printf("The %dth humble number is %I64d.\n",n,ans[n]);
    }
    return 0;
}

还可以用尺取法:

每个丑数乘上2,3,5,7都会生成另一个丑数,而且第2个丑数一定是第一个丑数乘2,3,7,5得到的四个数中最小的,第三个丑数肯定是第一个丑数乘3,7,5(第一个丑数乘2已用掉)和第二个丑数乘2得到的四个数中的最小值。

可以看出把乘的2,3,7,5当作对象,每次生成下一个丑数一定是2,3,7,5乘以当前最靠前的且没乘过的数。

所以用尺取法把四个乘数当成对象,设成4个坐标,初始化成1,一步一步向前推进,直到推进n次,复杂度O(N),很优。

//93MS 1112K
#include<stdio.h>
#include<algorithm>
#include<cstring>
using namespace std;
int ans[5850];
int main()
{
    int n;
    int a,b,c,d;
    ans[1]=1;
    a=b=c=d=1;
    int m=1;
    while(m <= 5842)
    {
        int tmp=min(min(2*ans[a], 3*ans[b]), min(5*ans[c], 7*ans[d]));//生成下一个丑数
        ans[++m]=tmp;
        //向前推进
        if(tmp==2*ans[a]) a++;
        if(tmp==3*ans[b]) b++;
        if(tmp==5*ans[c]) c++;
        if(tmp==7*ans[d]) d++;
    }
    while(~scanf("%d",&n) && n)
    {
        printf("The %d",n);
        if(n % 10 == 1 && n % 100 != 11)
            printf("st");
        else if(n % 10 == 2 && n % 100 != 12)
            printf("nd");
        else if(n % 10 == 3 && n % 100 != 13)
            printf("rd");
        else
            printf("th");
        printf(" humble number is %d.\n",ans[n]);
    }
    return 0;
}
时间: 2024-12-24 18:36:33

HDU 1058 Humble Numbers(递推)的相关文章

HDU 1058 Humble Numbers (dp+打表)

先是想筛法素数表啊,然后1~2000000000枚举打表啊,结果越想越不对. 后来想到唯一分解定理,可是怎么实现呢..果然还是需要努力啊.. 研究了discuss代码,码之~ ~~~~ dp的思想,若dp[i]是Humble Numbers,那么dp[i]*2,dp[i]*3,dp[i]*5,dp[i]*7都将是Humble Numbers. 所以只需要注意连续性便好了. #include<cstdio> #include<algorithm> #include<cmath&

HDU 1058 Humble Numbers (打表)

题目链接:HDU 1058 Humble Numbers 题意:一些数他们的素数因子只有2,3,5,7.求这些数. 因为这些数的因子只可能是2,3,5,7.所以通过2,3,5,7这个四个数构造这个数列,这个数列靠后的数必定是前面的数乘上2,3,5,7得到. AC代码: #include<stdio.h> #include<set> #define ll __int64 using namespace std; set<ll> s; set<ll>::iter

HDU 1058 Humble Numbers(DP,数)

题意  所有只能被2,3,5,7这4个素数整除的数称为Humble Number  输入n  输出第n个Humble Number 1是第一个humble number  对于一个Humble Number  a  有2*a,3*a,5*a,7*a都是Humble Number  可以以1为基数  依次展开即可得到一定范围内的Humble Number 用i,j,k,l分别记录 2,3,5,7分别乘到了第几个Humble Number  当前在计算第cnt个Humble Number  那么有

HDU 1058 Humble Numbers &amp;&amp; NOJ 1420 丑数 (数位dp)

Humble Numbers                          Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)                                          Total Submission(s): 18555    Accepted Submission(s): 8080 Problem Description A numb

hdu 1058 Humble Numbers || poj 1338(dp)

两题都是一样的题目 只是hdu 1058 多了个7 题意:求一个每个数因子仅含2 3 5 7 的 序列 问 第n个数是几 思路: ans[i]=min(min(ans[n2]*2,ans[n3]*3),min(ans[n5]*5,ans[n7]*7)); if(ans[i]==ans[n2]*2) n2++; if(ans[i]==ans[n3]*3) n3++; if(ans[i]==ans[n5]*5) n5++; if(ans[i]==ans[n7]*7) n7++; hdu 1058 #

hdu 1058 Humble Numbers

Humble Numbers Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 18406    Accepted Submission(s): 8010 Problem Description A number whose only prime factors are 2,3,5 or 7 is called a humble numbe

HDU 1058 Humble Numbers(dp)

Problem Description A number whose only prime factors are 2,3,5 or 7 is called a humble number. The sequence 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 12, 14, 15, 16, 18, 20, 21, 24, 25, 27, ... shows the first 20 humble numbers. Write a program to find and pri

HDU 1058.Humble Numbers【这个题怎么定位呢&#183;&#183;&#183;就【DP】吧】【8月28】

Humble Numbers Problem Description A number whose only prime factors are 2,3,5 or 7 is called a humble number. The sequence 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 12, 14, 15, 16, 18, 20, 21, 24, 25, 27, ... shows the first 20 humble numbers. Write a program

HDU 1058 Humble Numbers (DP)

Humble Numbers Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 18238    Accepted Submission(s): 7934 Problem Description A number whose only prime factors are 2,3,5 or 7 is called a humble numbe

HDU 1058 Humble Numbers (动规+寻找丑数问题)

Humble Numbers Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 16742    Accepted Submission(s): 7280 Problem Description A number whose only prime factors are 2,3,5 or 7 is called a humble numb